#include <stdlib.h>
#include <stdio.h>
#include "stack.h"

void push(struct stackelem** s,long long i,int c) {
  struct stackelem* x=malloc(sizeof(struct stackelem));
  x->val=i;x->next=*s;x->count=c;*s=x;
}

int pop(struct stackelem** s) {
  struct stackelem x=**s;*s=(*s)->next;return x.val;
}

int empty(struct stackelem* s) {
  return s==NULL;
}

void freestack(struct stackelem* s) {
  struct stackelem* t;
  if (!s)
    return;
  t=s->next;
  free(s);
  freestack(t);
}

struct stackelem* find(struct stackelem* s,long long val) {
  while (s!=NULL) {
    if (s->val==val)
      return s;
    s=s->next;
  }
  return NULL;
}
