#include <stdlib.h>



struct stackelem {
  long long val;
  int count;
  struct stackelem* next;
};


/************************* push ***************************
 This function pushes an int-Element on top of the stack.
 s ist a pointer to a pointer to the first element of the
 stack.
***********************************************************/
void push(struct stackelem** s,long long i,int c);

/* This function pops an element from top of the stack and
   returns the 'val'-field.
*/
int pop(struct stackelem** s);

/* This function returns 0 if the stack s is non-empty, 0
   otherwise.
*/
int empty(struct stackelem* s);

/* Frees the memory of the stack */
void freestack(struct stackelem* s);

/* This returns a stackelement with value==val */
struct stackelem* find(struct stackelem* s,long long val);
